<?php


namespace OrganizationsManagement\Service;

use OrganizationsManagement\Util\InstanceProvider;
use Doctrine\ORM\EntityManager;


class Cliente
{
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findAllClientes()
    {
        return InstanceProvider::getRepository()->getCliente()->findAllClientes();
    }
    
    public function findAllVersions()
    {
        return InstanceProvider::getRepository()->getCliente()->findAllVersions();
    }
    
    public function includeVersionsForClients($arrayNrversaodisp, $arrayCdClientes)
    {
        $return = [];
        $cdOperador = InstanceProvider::getLibEnvironment()->getCurrentUserId();
        foreach($arrayCdClientes as $cdcliente) {
           foreach($arrayNrversaodisp as $nrversaodisp) {
             try {
                  InstanceProvider::getRepository()->getCliente()->includeVersionsForClients($nrversaodisp, $cdcliente, $cdOperador);
             }catch(\Exception $e) {
                $return[] = ["CDCLIENTE" => $cdcliente, "NRVERSAODISP" => $nrversaodisp, "ERROR" => $e->getMessage()];
             }
           }
        }
        return $return;
    }
    
    public function includeVersionsForAllClients($arrayNrversaodisp)
    {
        $return = [];
        $cdOperador = InstanceProvider::getLibEnvironment()->getCurrentUserId();
        $allClientes = $this->findAllClientes();
        foreach($allClientes['data'] as $cliente) {
           foreach($arrayNrversaodisp as $nrversaodisp) {
             try {
                  InstanceProvider::getRepository()->getCliente()->includeVersionsForAllClients($nrversaodisp, $cliente['CDCLIENTE'], $cdOperador);
             }catch(\Exception $e) {
                $return[] = ["CDCLIENTE" => $cliente['CDCLIENTE'], "NRVERSAODISP" => $nrversaodisp, "ERROR" => $e->getMessage()];
             }
           }
        }
        return $return;
    }
    
    public function deleteVersionsForClients($arrayNrversaodisp, $arrayCdcliente)
    {
        $cdclientesString = "('" . implode("', '", $arrayCdcliente) . "')";
        InstanceProvider::getRepository()->getCliente()->deleteVersionsForClients($arrayNrversaodisp, $cdclientesString);
    }
    
    public function deleteVersionsForAllClients($arrayNrversaodisp)
    {
        $return = [];
        $allClientes = $this->findAllClientes();
        $allClientesArray = array_chunk($allClientes['data'], 999);
        foreach($allClientesArray as $cliente) {
             try {
                 $cdClientes = \OrganizationsManagement\Util\Utilities::getArrayFromArrayAssociative($cliente, 'CDCLIENTE');
                 InstanceProvider::getRepository()->getCliente()->deleteVersionsForAllClients($arrayNrversaodisp, $cdClientes);
             }catch(\Exception $e) {
                 $return[] = ["CDCLIENTE" => $cdClientes, "NRVERSAODISP" => $arrayNrversaodisp, "ERROR" => $e->getMessage()];
             }
        }
        return $return;
    }   
    
    public function findClientesWithLatestVersion()
    {
        return InstanceProvider::getRepository()->getCliente()->findClientesWithLatestVersion();
    }
    
    public function findVersionByCliente($cdcliente)
    {
        return InstanceProvider::getRepository()->getCliente()->findVersionByCliente($cdcliente);
    }
    
    public function deleteAllVersionByCliente($cdclientes)
    {
        $cdclientesString = "('" . implode("', '", $cdclientes) . "')";
        return InstanceProvider::getRepository()->getCliente()->deleteAllVersionByCliente($cdclientesString);
    }

    public function findClientesPorOperador($cdOperador)
    {
        return InstanceProvider::getRepository()->getCliente()->findClientesPorOperador($cdOperador);
    }

    public function findRelacionarClientesComOperador($cdoperador)
    {
        return InstanceProvider::getRepository()->getCliente()->findRelacionarClientesComOperador($cdoperador);
    }

    public function saveRelacionarClientesComOperador($clientes, $cdoperador, $idtpoperclie, $nrpriopercli)
    {
        $operclieFactory = InstanceProvider::getFactory()->getOperclie();
        $environment     = InstanceProvider::getLibEnvironment();
        $nrorg    = $environment->getCurrentOrganizationId();
        $currentOperator = $environment->getCurrentUserId();
        $dtAtual = new \DateTime();
        try {
            foreach ($clientes as $cliente) {
                $operclie = $operclieFactory->create($cliente['CDCLIENTE'], $cdoperador, $idtpoperclie,
                    $nrpriopercli, $nrorg, $currentOperator, $dtAtual);
                $this->entityManager->persist($operclie);
            }
            $this->entityManager->flush();
        } catch(\Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }

    public function deleteRelacionarClientesComOperador($clientes)
    {
        $operclieRepository = InstanceProvider::getRepository()->getOperclie();
        foreach ($clientes as $cliente) {
            /** @var \Teknisa\Model\Teknisa\Entities\Operclie $operclie */
            $operclie = $operclieRepository->findOneBy(array('cdcliente' => $cliente['CDCLIENTE'], 'cdoperador' => $cliente['CDOPERADOR']));
            $this->entityManager->remove($operclie);
        }
        $this->entityManager->flush();
    }
}
    
  