import { IEventParam, Metadata, Singleton } from '@zeedhi/core';
import { Menu, MenuButton } from '@zeedhi/common';
import { TekLibAuth } from '@zeedhi/tek-lib';

@Singleton
export class AppController {
	public microservicePage: boolean = false;

	public toggleMenu({ component }: IEventParam<MenuButton>) {
		const menu = Metadata.getInstance<Menu>(component.menuName);
		menu.toggleMenu();
		if (menu.drawer && !menu.miniState) {
			if (menu.showSearch) {
				setTimeout(() => {
					const searchInput = document.querySelector('.zd-menu-search-input input');
					if (searchInput) (searchInput as HTMLElement).focus();
				}, 100);
			} else {
				const firstMenuItem = document.querySelector('.zd-menu-link, .zd-menu-group > div');
				if (firstMenuItem) (firstMenuItem as HTMLElement).focus();
			}
		}
	}

	get userName() {
		return localStorage.getItem('LOGIN_USER_NAME');
	}

	public showMessageExpiredMenu() {
		TekLibAuth.showMessageExpiredMenu();
	}
}
